using System.Collections;
using UnityEngine;

public class FloorDuplicator : MonoBehaviour
{
    [SerializeField]
    private GameObject floorDuplicatorPrefab;

    // IEnumeratorを付けることでコルーチンとなります
    IEnumerator Start()
    {
        // 3秒待ちます(a)
        yield return new WaitForSeconds(3f);
        // 乱数で-1=左,0=前方,1=右に床を生成方向を決めます
        int direction = Random.Range(-1, 2);

        // Instantiate()関数で床をプレハブから生成します
        GameObject floorDuplicator = Instantiate(floorDuplicatorPrefab);
        // 床の幅を取得しまします
        float floorWidth = floorDuplicator.transform.localScale.x;
        // 床の奥行きを取得します
        float floorDepth = floorDuplicator.transform.localScale.z;
        // 床の幅と方向からX座標をいくらずらすか決めます(b)
        float floorOffsetX = floorWidth * direction;
        // 床の幅と方向からZ座標をいくらずらすか決めます(c)
        float floorOffsetZ = direction == 0 ? floorDepth : 0f;
        // 新しく生成した床の座標を設定します(d)
        floorDuplicator.transform.position =
            new Vector3(transform.position.x + floorOffsetX,
                        transform.position.y,
                        transform.position.z + floorOffsetZ);
    }
    void Update()
    {        
    }
}