using UnityEngine;

public class RollingBall : MonoBehaviour
{
    //⑧
    [SerializeField]
    private float moveForce = 5f;
    //⑥
    [SerializeField]//⑩
    private float jumpForce = 5f;
    //③
    private Rigidbody rigidBody;
    //⑪
    private bool isOnFloor = false;

    //④ここから
    private void Awake()
    {
        rigidBody = GetComponent<Rigidbody>();
    }
    //④ここまで
    // Start is called once before the first execution of Update after the MonoBehaviour is created
    void Start()
    {
        //②下記コードをコメントアウトまたは削除      
        //GetComponent<Rigidbody>().AddForce(new Vector3(5f, 0f, 0f), ForceMode.Impulse);//①
    }
    //⑤ここから
    void FixedUpdate()
    {
        if (Input.GetKey(KeyCode.W))
        {
            rigidBody.AddForce(new Vector3(0f, 0f, moveForce), ForceMode.Force);//⑨
        }
        if (Input.GetKey(KeyCode.S))
        {
            rigidBody.AddForce(new Vector3(0f, 0f, -moveForce), ForceMode.Force);//⑨
        }
        if (Input.GetKey(KeyCode.D))
        {
            rigidBody.AddForce(new Vector3(moveForce, 0f, 0f), ForceMode.Force);//⑨
        }
        if (Input.GetKey(KeyCode.A))
        {
            rigidBody.AddForce(new Vector3(-moveForce, 0f, 0f), ForceMode.Force);//⑨
        }
    }
    //⑤ここまで
    // Update is called once per frame
    void Update()
    {
        //⑦ここから
        if (isOnFloor && Input.GetKeyDown(KeyCode.Space))//⑮条件変更
        {
            rigidBody.AddForce(new Vector3(0f, jumpForce, 0f), ForceMode.Impulse);
        }
        //⑦ここまで
    }
    //⑫ここから
    private void OnCollisionEnter(Collision collision)
    {
        if (collision.gameObject.tag == "Floor")
        {
            isOnFloor = true;
        }
    }
    //⑫ここまで
    //⑬ここから
    private void OnCollisionStay(Collision collision)
    {
        if (collision.gameObject.tag == "Floor")
        {
            isOnFloor = true;
        }
    }
    //⑬ここまで
    //⑭ここから
    private void OnCollisionExit(Collision collision)
    {
        if (collision.gameObject.tag == "Floor")
        {
            isOnFloor = false;
        }
    }
    //⑭ここまで
}