using System.Collections;
using UnityEngine;

public class FloorDuplicator : MonoBehaviour
{
    //⑧
    private static int totalFloorCountToGoal = 5;
    //⑨
    public static int createdFloorCounter = 1;
    //⑩
    [SerializeField]
    private GameObject goalPrefab;


    [SerializeField]
    private GameObject floorDuplicatorPrefab;

    //④ここから
    [SerializeField]
    private float destroyTime = 6f;
    //④ここまで

    //①生成元の方向
    private int backtrackDirection = 0;

    // IEnumeratorを付けることでコルーチンとなります
    IEnumerator Start()
    {
        // 3秒待ちます(a)
        yield return new WaitForSeconds(3f);
        // 乱数で-1=左,0=前方,1=右に床を生成方向を決めます
        int direction = Random.Range(-1, 2);

        //②ここから
        if (direction != 0 && direction == backtrackDirection)
        {
            // 生成元の方向の場合前方に変更する。
            direction = 0;
        }
        //②ここまで
        //⑪ここから
        GameObject floorDuplicator = null;
        if (createdFloorCounter == totalFloorCountToGoal)
        {
            floorDuplicator = Instantiate(goalPrefab);
        }
        else
        {
            // Instantiate()関数で床をプレハブから生成します
            floorDuplicator = Instantiate(floorDuplicatorPrefab);
            //③生成先の方向にマイナスを掛けると生成元の方向になります
            floorDuplicator.GetComponent<FloorDuplicator>().backtrackDirection = -direction;
        }
        //⑪ここまで
        // 床の幅を取得しまします
        float floorWidth = floorDuplicator.transform.localScale.x;
        // 床の奥行きを取得します
        float floorDepth = floorDuplicator.transform.localScale.z;
        // 床の幅と方向からX座標をいくらずらすか決めます(b)
        float floorOffsetX = floorWidth * direction;
        // 床の幅と方向からZ座標をいくらずらすか決めます(c)
        float floorOffsetZ = direction == 0 ? floorDepth : 0f;
        // ⑥床のYの座標設定
        float floorOffsetY = Random.Range(-1, 2) * floorDuplicator.transform.localScale.y;        // 新しく生成した床の座標を設定します(d)
        floorDuplicator.transform.position =
            new Vector3(transform.position.x + floorOffsetX,
                        transform.position.y + floorOffsetY,//⑦変更
                        transform.position.z + floorOffsetZ);
        //⑫
        ++createdFloorCounter;

        //⑤ここから
        // 6秒待って破棄します
        yield return new WaitForSeconds(destroyTime);
        Destroy(gameObject);
        //⑤ここまで
    }
    void Update()
    {        
    }
}