using UnityEngine;
using UnityEngine.AI;

public class Enemy : MonoBehaviour
{
    private GameObject playerGameObject;
    private NavMeshAgent navMeshAgent;

    void Awake()
    {
        //NavMeshAgentのコンポーネントを取得します。
        navMeshAgent = GetComponent<NavMeshAgent>();
    }
    void Start()
    {
        //ターゲットとなるプレイヤーのゲームオブジェクトを取得します。
        playerGameObject = GameObject.FindGameObjectWithTag("Player");
    }
    void Update()
    {
        //NavMeshAgentに目的地(プレイヤーの座標)を設定します。
        navMeshAgent.destination = playerGameObject.transform.position;
    }
}