using System.Collections.Generic;
using UnityEngine;
//⑥
using UnityEngine.Events;

public class GameManager : MonoBehaviour
{
    //③ここから
    [SerializeField]
    //"GOAL"の参照です。
    GameObject goalText;

    //⑦ここから
    [SerializeField]
    public UnityEvent OnPlayerGoal = new UnityEvent();
    //⑦ここまで

    // ゴールしたかどうか？
    public bool IsPlayerArrivedAtGoal { get; private set; } = false;
    //③ここまで

    public int TotalItemCount => itemGoldList.Count;
    private List<ItemGold> itemGoldList = new List<ItemGold>();
    //①ここから
    // GoalPointのゲームオブジェクトを保持します。
    private GameObject goalPoint;
    private void Start()
    {
        //GoalPointのゲームオブジェクトを検索します。
        goalPoint = GameObject.FindGameObjectWithTag("GoalPoint");
        //GoalPointのゲームオブジェクトを非表示にします。
        goalPoint.SetActive(false);
        //④"GOAL"を非表示にします。
        goalText.SetActive(false);
    }
    //①ここまで
    //⑤ここから "GOAL"を表示します。
    public void PlayerArrivedAtGoal()
    {
        if (!IsPlayerArrivedAtGoal)
        {
            IsPlayerArrivedAtGoal = true;
            goalText.SetActive(true);
            //⑧
            OnPlayerGoal.Invoke();
        }
    }
    //⑤ここまで
    public void AddItem(ItemGold itemGold)
    {
        itemGoldList.Add(itemGold);
    }
    public void RemoveItem(ItemGold itemGold)
    {
        itemGoldList.Remove(itemGold);
        //②ここから
        if (itemGoldList.Count == 0)
        {
            goalPoint.SetActive(true);
        }
        //②ここまで
    }
}