using UnityEngine;

public class Bullet : MonoBehaviour
{
    // Rigidbody2Dコンポーネントへの参照
    private Rigidbody2D rigidbody2d;

    // どのプレイヤーの弾か?
    public int playerIndex { get; set; }

    private void Awake()
    {
        rigidbody2d = GetComponent<Rigidbody2D>();
    }

    public void Move(Vector2 velocity, int playerIndex)
    {
        // 移動速度をセットします
        rigidbody2d.linearVelocity = velocity;
        // 誰の弾かを識別するための番号です
        this.playerIndex = playerIndex;
    }
    private void Update()
    {
        // 画面外に出たら破棄します
        Vector3 screenPosition = Camera.main.WorldToScreenPoint(transform.position);
        if (screenPosition.x < 0f || screenPosition.x > Screen.width
            || screenPosition.y < 0f || screenPosition.y > Screen.height)
        {
            Destroy(gameObject);
        }
    }
}