using System.Collections.Generic;
using UnityEngine;
using TMPro;

public class HudManager : MonoBehaviour
{
    // "Text 1P Score"と"Text 2P Score"を順にセットしてください
    [SerializeField]
    List<TextMeshProUGUI> scoreTextList;
    // プレイヤー1と2の得点を保持しています
    List<int> score;

    private void Awake()
    {
        // 得点の配列を作成します。初期値は0になります。
        score = new List<int>(new int[scoreTextList.Count]);
    }

    // index番目プレイヤーの得点を1点加算して、表示します
    // index 0=Player1, 1=Player2
    public void AddScoreText(int index)
    {
        ++score[index];
        scoreTextList[index].text = $"Score {score[index]}";
    }
}